"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

require("./style.css");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var MultiStateButtonComponent =
/*#__PURE__*/
function (_Component) {
  _inherits(MultiStateButtonComponent, _Component);

  function MultiStateButtonComponent(props) {
    var _this;

    _classCallCheck(this, MultiStateButtonComponent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(MultiStateButtonComponent).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleClick", function () {
      var keys = Object.keys(_this.props.options);
      var currentIndex = keys.indexOf(_this.state.currentState);
      var nextIndex = currentIndex;

      if (currentIndex < keys.length - 1) {
        nextIndex = currentIndex + 1;
      } else {
        if (_this.props.loop) {
          nextIndex = 0;
        }
      }

      _this.setState({
        currentState: keys[nextIndex]
      });

      _this.props.onChange(keys[nextIndex]);
    });

    _this.state = {
      currentState: _this.props.defaultValue
    };
    return _this;
  }

  _createClass(MultiStateButtonComponent, [{
    key: "render",
    value: function render() {
      var options = this.props.options;
      return _react.default.createElement("button", {
        onClick: this.handleClick,
        style: {
          color: options[this.state.currentState].color,
          background: options[this.state.currentState].background
        },
        className: "btn multiStateBtn multiStateBtn-".concat(this.state.currentState)
      }, options[this.state.currentState].text);
    }
  }]);

  return MultiStateButtonComponent;
}(_react.Component);

var _default = MultiStateButtonComponent;
exports.default = _default;